unit Mode13;
{Mode13.pas - Simple Unit for mode 13h for Borland/Turbo Pascal 7.0+

Created in 10/15/1997 by FJTC for the e-Software Game Programming Homepage
Last Update 10/15/1997


Disclamer:
==========

	We shall not assume any damage that the contents of this file could cause
to your computer, brain or ANYTHING related you. We are not kidding.
	Use it by yourself.

Contents:
=========

	This file contains functions to Initialize, Close and plot a point under
Mode 13h (320x200x256).


Distribution Notes:
===================

	You can:
   	- Use it
      - Modify it
      - Eat it
      - And distribute it without modifications
   But you can not:
		- Sell it

Contact Us:
===========

	Contact us at:
      http://www.icmsc.sc.usp.br/~andreeta/e-Software
   	http://www.icmsc.sc.usp.br/~chino/e-Software

	Or via e-Mail to:
   	chino@icmsc.sc.usp.br (FJTC)
   	morelli@icmsc.sc.usp.br (Cyclops)
   	andreeta@icmsc.sc.usp.br (MLBA)


								THANK YOU FOR VISITING US
}

interface

   procedure InitMode13;
   {Start Bios Mode 13h - 320x200x256}

   procedure RestoreTextMode;
   {Restore Default Text mode}

   procedure PSet(X, Y: Integer; Color: Byte);
	{Set a pixel under mode 13h}


implementation

   procedure InitMode13;
   {Start Bios Mode 13h - 320x200x256}
   	Begin
         {Call service 00h of the BIOS interruption 10h.
			 Parameter AL = 13h(Video number)}
	     	ASM
         	xor AH, AH	{AH = 0h}
         	mov AL, 13h	{AL = 13h}
            int 10h		{Call Interrupt 10h (Video Interrupt)}
         End;{Asm}
      End;{InitMode13}

   procedure RestoreTextMode;
   {Restore Default Text mode}
   	Begin
         {Call service 00h of the BIOS interruption 10h.
			 Parameter AL = 3h(Video number)}
	     	ASM
         	xor AH, AH	{AH = 0h}
         	mov AL, 3h	{AL = 3h}
            int 10h		{Call Interrupt 10h (Video Interrupt)}
         End;{Asm}
      End;{RestoreTextMode}

   procedure PSet(X, Y: Integer; Color: Byte);
	{Set a pixel under mode 13h}
   	begin
         {Clipping to screen}
      	if (X > -1) and (X < 320) and
            (Y > -1) and (Y < 200) Then
            Begin
					{Now, you must set the position X + Y * 320 of the Video
					Memory Segment (A000h) to plot the point}
               ASM
                  {Calculate Y * 320 + X}
               	mov AX, Y		{AX = Y}
                  mov BX, AX		{BX = Y}
						shl AX, 6		{AX = AX * 64}
						shl BX, 8		{BX = BX * 256}
                  add BX, AX		{BX = Y * 64 + Y * 256 = Y * 320}
                  add BX, X		{BX = BX + X}
                  mov AL, Color	{AL = Color}
                  {Now, put the point}
                  mov DI, SEGA000{DI = A000h}
                  mov ES, DI		{ES = A000h, there are no other fast way to do this}
						mov ES:[BX], AL{It's done}
               End;{ASM}
            End;{If}
      End;{Pset}

end.